#include "main.h"

void base_update_limit(base *b)
{
  pkt_list_entry *ple;
  unsigned int limit = (unsigned int)-1;

  if(!b->packages)
    limit = 0;
  else
    for(ple = b->packages->first; ple; ple=ple->next)
      {
	if(ple->entry->weight == -1)
	  {
	    limit = 0;
	    break;
	  }
	if(ple->entry->weight < limit)
	  limit = ple->entry->weight;
      }
  b->limit = limit;
}

unsigned int allbases_limit(bases *bs)
{
  unsigned int lim = (unsigned int)-1;
  base *b;
  for(b = bs->first; b; b=b->next)
    if(lim < b->limit)
      lim = b->limit;
  return lim;    
}

base *add_base(bases *bs,int x,int y)
{
  base *b=(base *)calloc(1,sizeof(base));
  b->x=x;
  b->y=y;
  b->packages = NULL;
  b->next=bs->first;
  bs->first=b;
  if (!bs->last)
    bs->last=b;
  bs->nb_bases++;
  return b;
}

void remove_base(bases *bs,int x,int y)
{
  base *b=find_base(bs,x,y);
  b->limit=((unsigned int)(-1));
}

bases *init_bases(env *e)
{
  int x, y;
  bases *bs=(bases *)calloc(1,sizeof(bases));
  base *bas;
  for (x=0;x<e->b->width;x++)
    for(y=0;y<e->b->height;y++)
      if (e->b->tiles[x][y].terrain==BASE)
	{
	  printf("new base at %d,%d\n",x,y);
	  bas=add_base(bs,x,y);
	}
  return bs;
}


void lookup_all_bases(env *e)
{
  base *b=e->bs->first;
  while(b)
    {
      (void)bedford_lookup_target(e,b->x,b->y);
      b=b->next;
    }
}

base *find_base(bases *bs,int x,int y)
{
  base *b=bs->first;
  while(b)
    {
      if ((b->x==x) && (b->y==y))
	return b;
      b=b->next;
    }
  return NULL;
}

void print_bases(env *e)
{
  base *b=e->bs->first;
  while(b)
    {
      printf("base at %d,%d\n",b->x,b->y);
      b=b->next;
    }
}
