#ifndef _bedford_h_
#define _bedford_h_

#include "board.h"
#include "env.h"

typedef struct bedford_entry {
  int targetx, targety;
  unsigned int **dist;
  struct bedford_entry *next;
  struct bedford_entry *prev;
} bedford_entry;

typedef struct bedford_table {
  int maxsize;
  int cursize;
  bedford_entry *first;
  bedford_entry *last;
} bedford_table;

struct env;
struct board;
bedford_table *create_bedford_table(int maxsize);
bedford_entry *bedford_lookup_target(struct env *e, int x, int y);
char bestmove(struct env *e, bedford_entry *target);

#endif
