#include "main.h"

board *get_board(int soc)
{
  char *line;
  int x, y;
  board *b=(board *)calloc(1,sizeof(board));
  char buf[1024]; /*TODO reduire*/

  if (read_line(soc,buf,1024)<0)
    return NULL;
  sscanf(buf,"%d %d",&b->width,&b->height);
  printf("board dimension : width=%d height=%d\n",b->width,b->height);

  b->width += 2;
  b->height += 2;
  assert(b->width>2);
  assert(b->height>2);
  assert(b->width<=10002);
  assert(b->height<=10002);

  line=(char *)calloc(b->width+24,sizeof(char));
  b->tiles=(tile **)calloc(b->width,sizeof(tile *));
  for(x=0; x<b->width; x++)
    b->tiles[x]=(tile *)calloc(b->height,sizeof(tile));
  for(x = 0; x < b->width; x++)
    {
      b->tiles[x][0].terrain = WALL; 
      b->tiles[x][0].id =-1;
      b->tiles[x][b->height-1].terrain = WALL;
      b->tiles[x][b->height-1].id = -1;
    }
  for(y = 0; y < b->height; y++)
    {
      b->tiles[0][y].terrain = WALL; 
      b->tiles[0][y].id =-1;
      b->tiles[b->width-1][y].terrain = WALL;
      b->tiles[b->width-1][y].id = -1;
    }

  for(y=1; y<b->height-1; y++)
    {
      if (read_line(soc,line,b->width+12)<0)
	return NULL;
      for (x=1; x<b->width-1; x++) 
	{
	  b->tiles[x][y].terrain = line[x-1];
	  b->tiles[x][y].id = -1;
	  b->tiles[x][y].packages = NULL;
	}
    }
  free(line);
  return b;
}

#ifdef GUI
struct guitoken {
  char type;
  int  id;
  unsigned int distance;
};
#endif

void display_board(FILE *stream, env *e)
{
#ifdef GUI
  int x,y;
  board *b = e->b;
  struct guitoken gt;

  for(y = 0; y < b->height; y++) {
    for(x = 0; x < b->width; x++)
      {
	gt.id = b->tiles[x][y].id;
	gt.type = b->tiles[x][y].terrain;
	if(e->bt->first)
	  gt.distance = e->bt->first->dist[x][y]+e->topo_layer[x][y];
	else
	  gt.distance = (unsigned int)-1;
	gui_write(&gt, sizeof(struct guitoken));
      }
  }
#endif
}

