#ifndef _env_h_
#define _env_h_

#include "pkt.h"
#include "player.h"
#include "board.h"
#include "bedford.h"
#include "base.h"
#include "layer.h"

#define NORTH 'N'
#define WEST  'W'
#define EAST  'E'
#define SOUTH 'S'

#define TBASE 1
#define TDEST 2
#define TDP   3

#define vabs(a) ((a)<0?-(a):(a))

typedef struct env {
  board *b;
  int initial_capacity;
  int initial_money;
  player *p;
  player_list adv;
  pkt_list known;
  bedford_table *bt;
  int state;
  int soc;
  bases *bs;
  char target_type;
  bedford_entry *target;
  int continue_to_hit;
  int ** topo_layer;
  target_list targs;
} env;

void display_env(FILE *stream, env *e);
env *init(char *, unsigned short);
int parse_server_response(char *response, env *e);
int round(env *e);

void move(int bid, env *e, char direction);
void pick(int bid, env *e, pkt_list *pl);
void drop(int bid, env *e, pkt_list *pl);
void stay(int bid,env *e);
#endif
