#include "gui.h"
#include <signal.h>

#ifdef GUI

static int guisocket = -1;

void onsigpipe(int s)
{
  close(guisocket);
  guisocket = -1;
}

void gui_init(char *servername, unsigned short port)
{
  struct hostent * serv;
  struct sockaddr_in server;
  
  signal(SIGPIPE, onsigpipe);

  /*creation de la socket*/
  guisocket=socket(AF_INET,SOCK_STREAM,0);
  
  /*collecte d'infos*/
  if ((serv=(struct hostent *)gethostbyname(servername))==NULL)
    {
      perror("gethostbyname");
      return;
    }
  
  /*remplissage de la structure de description du serveur*/
  bzero(&server,sizeof(server));
  server.sin_family=AF_INET;
  memcpy(&server.sin_addr,serv->h_addr,serv->h_length);
  server.sin_port=htons(port);
  
  /*connexion*/
  if (connect(guisocket,(struct sockaddr *)&server,sizeof(server))<0)
    {
      close(guisocket);
      perror("connect");
    }
}

void gui_write(void *txt, int size)
{
  if(guisocket >= 0)
    if( send(guisocket, txt, size, MSG_NOSIGNAL) != size )
      {
	perror("gui::send");
	close(guisocket);
	guisocket = -1;
      }
}

#endif
