#include "main.h"

#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

#ifdef NDEBUG
int printf(const char *format, ...) { return 0; }
#endif

int main(int argc,char **argv)
{
  env *e;
  int r;
  struct rusage f;

  if (argc<3)
    {
#ifdef GUI
      fprintf(stderr, "usage : %s server_name server_port [gui_server_name gui_server_port]\n", argv[0]);
#else
      fprintf(stderr, "usage : %s server_name server_port\n", argv[0]);      
#endif
      exit(0);
    }

#ifdef GUI
  if(argc > 3)
    gui_init(argv[3], atoi(argv[4]));
#endif

  getrusage( RUSAGE_SELF, &f );

  e = init(argv[1],atoi(argv[2]));

  if (!e)
    {
      printf("cannot initialize\n");
      exit(0);
    }

  display_env(stdout, e);

  printf("go into game\n");

  r = 0;
  while(round(e) >= 0) {
    display_env(stdout, e);
    r++;
  }
   
  close(e->soc);
  
  getrusage( RUSAGE_SELF, &f );
  fprintf(stderr, "%d rounds in %lus and %lu micoseconds\n", r, 
	  (long unsigned int)f.ru_utime.tv_sec, 
	  (long unsigned int)f.ru_utime.tv_usec );
  fprintf(stderr, "%lu pages of memory maximum\n",
	  (long unsigned int)f.ru_maxrss);
  fprintf(stderr, "Hope you had a good score\n");
  
  return 0;
}
