#include "main.h"

int read_line(int soc,char *buf,int size)
{
  int i=0;
  char c;

  while((recv(soc,&c,1,0)==1) && (i<size))
    {  
      if (c!='\n')
	buf[i++]=c;
      else
	{
	  buf[i]=0;
#ifdef DEBUG_NET
	  printf("S: %s\n", buf);
#endif
	  return i;
	}
    }
  if (i==size)
    {
      printf("read_line : buffer to small\n");
      return -1;
    }
  perror("read_line : receive");
  return -1;
}

char *getnextline(int soc)
{
  static char *line = NULL;
  static int linesize = 0;
  int i = 0;
  char c;
  
  if(!linesize)
    {
      linesize = 4096;
      line = (char *)calloc(linesize, sizeof(char));
    }

  while( recv(soc, &c, 1, 0) == 1 )
    {
      if (c!='\n')
	line[i++] = c;
      else
	{
	  line[i] = 0;
#ifdef DEBUG_NET
	  printf("S: %s\n", line);
#endif
	  return line;
	}
      if(i >= linesize)
	{
	  linesize *= 2;
	  line = (char*)realloc(line, linesize);
	}
    }

  perror("read_line : receive");
  return NULL;
}

int init_net(char *c_server, unsigned short port)
{
  int soc;
  struct hostent * serv;
  struct sockaddr_in server;

  /*creation de la socket*/
  soc=socket(AF_INET,SOCK_STREAM,0);

  /*collecte d'infos*/
  if ((serv=(struct hostent *)gethostbyname(c_server))==NULL)
    {
      perror("gethostbyname");
      return -1;
    }

  /*remplissage de la structure de description du serveur*/
  bzero(&server,sizeof(server));
  server.sin_family=AF_INET;
  memcpy(&server.sin_addr,serv->h_addr,serv->h_length);
  server.sin_port=htons(port);

  /*connexion*/
  if (connect(soc,(struct sockaddr *)&server,sizeof(server))<0)
    {
      close(soc);
      perror("connect");
      return -1;
    }

  return soc;
}


