#include "main.h"

pkt_entry *pkt_lookup_or_add(env *e, int id, int weight, int xhome, int yhome,
			     int x, int y)
{
  pkt_entry *pe;
  pkt_list_entry *ple;
  base *b;

  for(ple = e->known.first; ple; ple = ple->next)
    if(id == ple->entry->id)
      break;
  if(!ple)
    {
      pe = pkt_add_by_id(&e->known, id);
      b = find_base(e->bs, x, y);
      if(b)
	{
	  if(!b->packages) b->packages = pkt_init();
	  pkt_add_entry(b->packages, pe);
	}
    }
  else
    pe = ple->entry;

  if(pe->weight == -1) pe->weight = weight;
  if(pe->xhome  == -1) pe->xhome  = xhome;
  if(pe->yhome  == -1) pe->yhome  = yhome;
  if(pe->x      == -1) pe->x      = x;
  if(pe->y      == -1) pe->y      = y;

  if(pe->weight != -1)
    e->known.total_weight += pe->weight;

  return pe;
}

pkt_entry *pkt_lookup_or_add_by_id(env *e, int id)
{
  pkt_entry *pe;
  pkt_list_entry *ple;

  for(ple = e->known.first; ple; ple = ple->next)
    if(id == ple->entry->id)
      break;
  if(!ple)
    pe = pkt_add_by_id(&e->known, id);
  else
    pe = ple->entry;

  if(pe->weight != -1)
    e->known.total_weight += pe->weight;

  return pe;
}

void add_targ(target_list *tl,int x,int y)
{
  targ *ta=(targ *)calloc(1,sizeof(targ));
  ta->x=x;
  ta->y=y;
  ta->next=tl->first;
  tl->first=ta;
}

int exists_targ(target_list *tl,int x,int y)
{
  targ *ta=NULL;
  if (!tl)
    return 0;
  ta=tl->first;
  while(ta)
    {
      if ((ta->x==x) && (ta->y==y))
	return 1;
      ta=ta->next;
    }
  return 0;
}

pkt_list *parse_package_list(char *desc, env *e)
{
  char *d;
  int id, x, y, w;
  pkt_list *p = (pkt_list *)calloc(1, sizeof(pkt_list)); 
  pkt_entry *pe;

  if(strstr(desc, "Robot") && strstr(desc, "died"))
    return NULL;

  d = desc;
  while(*d) {
    id = strtol(d, &d, 10);
    assert(*d == ' ');
    d++;
    
    x = strtol(d, &d, 10);
    assert(*d == ' ');
    d++;
    
    y = strtol(d, &d, 10);
    assert(*d == ' ');
    d++;

    w = strtol(d, &d, 10);
    if(*d == ' ')
      d++;
    else
      assert(*d == 0);

    pe = pkt_lookup_or_add(e, id, w, x, y, e->p->x, e->p->y);
    if (!exists_targ(&(e->targs),x,y))
      {
	add_targ(&(e->targs),x,y);
      }
    pkt_add_entry(p, pe);
  }

  return p;
}

pkt_list * pkt_init()
{
  pkt_list *l=(pkt_list *)calloc(1,sizeof(pkt_list));
  return l;
}

void remove_dropped_packet(env *e)
{
  pkt_list_entry *ple;

  for(ple = e->known.first; ple; ple = ple->next)
    if ((ple->entry->x==e->p->x) && (ple->entry->y==e->p->y))
      {
	ple->entry->state=PDESTROYED;
	ple->entry->xhome=e->p->x;
	ple->entry->yhome=e->p->y;
      }
}

pkt_entry *pkt_add_by_id(pkt_list *l, int id)
{
  pkt_entry *e = (pkt_entry *)calloc(1, sizeof(pkt_entry));

  e->id     = id;
  e->weight = -1;
  e->xhome  = -1;
  e->yhome  = -1;
  e->x      = -1;
  e->y      = -1;
  e->state  = PUNKNOW;

  pkt_add_entry(l, e);
  return e;
}

pkt_list *binpack(pkt_list *pk, int max_capacity, env *e)
{
  float value=0;
  float test_value=0;
  int bigger = 0;
  pkt_entry *best_entry;
  targ *ta=e->targs.first;
  pkt_list_entry *ce;
  bedford_entry * be;
  pkt_list_entry *ple;
  targ *best_target=NULL;
  
  assert (pk->first!=NULL);

  printf("real capacity : %d\n",max_capacity);

  while(ta)
    {
      ta->pktl=pkt_init();
      ta->realcap=max_capacity;
      bigger=0;
      best_entry=NULL;
      for(ce = pk->first; ce; ce=ce->next) 
	{
	  if ((ce->entry->xhome==ta->x) && (ce->entry->yhome==ta->y))
	    {
	      if ((ce->entry->weight<=ta->realcap) && (ce->entry->weight>bigger))
		{
		  best_entry=ce->entry;
		  bigger=ce->entry->weight;
		}
	    }
	}
      if (best_entry)
	{
	  /*printf("for destination %d,%d taking packet : weight %d \n",ta->x,ta->y,best_entry->weight);*/
	  pkt_add_entry(ta->pktl, best_entry);
	  ta->best_id=best_entry->id;
	  ta->realcap-=bigger;
	}
      ta=ta->next;
    }


  ta=e->targs.first;
  while(ta)
    {
      /*printf("target : %d,%d\n",ta->x,ta->y);*/
      for(ce = pk->first; ce; ce=ce->next) 
	{
	  if ((ce->entry->xhome==ta->x) && (ce->entry->yhome==ta->y))
	    {
	      if ((ce->entry->weight<=ta->realcap) && (ce->entry->id!=ta->best_id))
		{
		  /*printf("2 : for destination %d,%d taking packet : x %d y %d weight %d\n",ta->x,ta->y,ce->entry->xhome,ce->entry->yhome,ce->entry->weight);*/
		  pkt_add_entry(ta->pktl, ce->entry);
		  ta->realcap-=ce->entry->weight;
		}
	      else
		{
		  printf("2 : rejected weight : %d because %d\n",ce->entry->weight,ta->realcap);
		}
	    }
        }
      ta=ta->next;
    }

  be=bedford_lookup_target(e,e->p->x,e->p->y);
  value=0.0;
  ta=e->targs.first;
  while(ta)
    {
      test_value=((float)(ta->pktl->total_weight))/((float)(be->dist[ta->x][ta->y]));
      if (test_value>value)
	{
	  printf("choosen\n");
	  value=test_value;
	  best_target=ta;
	}
      else
	{
	  printf("rejected value : %f\n",test_value);
	}
      ta=ta->next;
    }

  if (!best_target)
    return NULL;

  be=bedford_lookup_target(e,best_target->x,best_target->y);
  
  for(ce = pk->first; ce; ce=ce->next) 
    {
      for(ple = best_target->pktl->first; ple; ple=ple->next)
	if(ple->entry == ce->entry)
	  break;
      if(ple)
	continue; 
      if ((be->dist[ce->entry->xhome][ce->entry->yhome]<=BINPACK_RADIUS(e)) 
	  && (ce->entry->weight<=best_target->realcap))
	{
	  pkt_add_entry(best_target->pktl,ce->entry);
	  best_target->realcap-=ce->entry->weight;
	}
    }

  return best_target->pktl;
}


pkt_list *binpack_add(pkt_list *pk,pkt_list *bag,int max_capacity, env *e)
{
  int realcap=max_capacity;
  pkt_list *sub=pkt_init();
  pkt_list_entry *ce;
  bedford_entry *be;

  assert(bag->first);
  be=bedford_lookup_target(e,bag->first->entry->xhome,bag->first->entry->yhome);
  for(ce = pk->first; ce; ce=ce->next) 
    {
      if ((be->dist[ce->entry->xhome][ce->entry->yhome]<=BINPACK_RADIUS(e)) 
	  && (ce->entry->weight<=realcap))
	{
	  pkt_add_entry(sub,ce->entry);
	  realcap-=ce->entry->weight;
	}
    }
  if (sub->first)
    return sub;
  else
    {
      pkt_free(sub);
      return NULL;
    }
}


pkt_list *pkt_select_at_location(pkt_list *pk, int x,int y)
{
  pkt_list *ret;
  pkt_list_entry *e;
  
  ret = pkt_init();
  
  for(e = pk->first; e; e=e->next) {
    if ((e->entry->xhome==x) && (e->entry->yhome==y))
      {
	pkt_add_entry(ret, e->entry);
      }
    }
    
  return ret;
}

void pkt_add_entry(pkt_list *l, pkt_entry *pe)
{
  pkt_list_entry *le = (pkt_list_entry *)calloc(1, sizeof(pkt_list_entry));
  assert(pe!=NULL);
  le->next  = NULL;
  le->entry = pe;
  if(l->first) 
    {
      le->prev = l->last;
      l->last->next = le;
    }
  else
    {
      l->first = le;
      le->prev=NULL;
    }
  l->last = le;
  l->nb_pkt++;
  if( pe->weight != -1)
    l->total_weight += pe->weight;
}

void pkt_free(pkt_list *l)
{
  pkt_list_entry *e;
  if(!l)
    return;
  if(l->first) 
    {
      for(e = l->first->next; e; e=e->next)
	free(e->prev);
      free(l->last);
    }
  free(l);  
}

void pkt_remove_entry(pkt_list *l, pkt_entry *pe)
{
  pkt_list_entry *ple;

  for(ple = l->first; ple; ple=ple->next)
    if(ple->entry == pe) {
      if(ple->prev)
	ple->prev->next = ple->next;
      if(ple->next)
	ple->next->prev = ple->prev;
      if (!ple->prev)
	l->first=ple->next;
      if (!ple->next)
	l->last=ple->prev;
      if(pe->weight != -1)
	l->total_weight -= pe->weight;
      l->nb_pkt--;
      free(ple);
      return;
    }
}

void display_packages(FILE *stream, pkt_list *pl)
{
#ifdef GUI
  pkt_list_entry *ple;
  gui_write(&pl->nb_pkt, sizeof(int));
  gui_write(&pl->total_weight, sizeof(int));
  for(ple = pl->first; ple; ple=ple->next) {
    gui_write(&ple->entry->id, sizeof(int));
    gui_write(&ple->entry->weight, sizeof(int));
    gui_write(&ple->entry->x, sizeof(int));
    gui_write(&ple->entry->y, sizeof(int));
    gui_write(&ple->entry->xhome, sizeof(int));
    gui_write(&ple->entry->yhome, sizeof(int));
    gui_write(&ple->entry->state, sizeof(char));
  }
#endif
}


void display_packages_text(FILE *stream, pkt_list *pl)
{
  pkt_list_entry *ple;
  fprintf(stream, "%d packages for a total weight of %dlb\n",
	  pl->nb_pkt, pl->total_weight);
  for(ple = pl->first; ple; ple=ple->next)
    fprintf(stream, "  %d[%d, %d]->(%d, %d) ", ple->entry->id,
	    ple->entry->x, ple->entry->y, ple->entry->xhome,
	    ple->entry->yhome);
  fprintf(stream, "\n");
}

pkt_list *pkt_list_clone(pkt_list *l)
{
  pkt_list_entry *ple;
  pkt_list *sub;

  sub = pkt_init();
  for(ple = l->first; ple; ple = ple->next)
    pkt_add_entry(sub, ple->entry);
  return sub;
}
