#ifndef _pkt_h_
#define _pkt_h_

#define PONFLOOR 1
#define PDESTROYED 2
#define PCARRIED 3
#define PUNKNOW 4
#define PDESTROYEDBYUS 5

#define USABLE(e) (((e)->x!=-1) && ((e)->y!=-1) && \
(((e)->state==PONFLOOR) || ((e)->state==PUNKNOW)))

typedef struct pkt_entry {
  int id;
  int weight;
  int x,  y;
  int xhome;
  int yhome;
  char state;
} pkt_entry;

typedef struct pkt_list_entry {
  pkt_entry        *entry;
  struct pkt_list_entry *next;
  struct pkt_list_entry *prev;
} pkt_list_entry;

typedef struct pkt_list {
  int nb_pkt;
  int total_weight;
  pkt_list_entry *first;
  pkt_list_entry *last;
} pkt_list;

typedef struct targ {
  int x;
  int y;
  int realcap;
  int best_id;
  pkt_list *pktl;
  struct targ *next;
}targ;

typedef struct target_list {
  targ *first;
  targ *last;
} target_list;

struct env;
pkt_list *parse_package_list(char *desc, struct env *e);

pkt_list * pkt_init();
void pkt_free(pkt_list *l);
void display_packages(FILE *stream, pkt_list *pl);

void pkt_add_entry(pkt_list *l, pkt_entry *pe);
void pkt_remove_entry(pkt_list *l, pkt_entry *pe);
pkt_list *pkt_list_clone(pkt_list *l);

pkt_entry *pkt_add_by_id(pkt_list *l, int id);
pkt_entry *pkt_lookup_or_add(struct env *e, int id, int weight, 
			     int xhome, int yhome, int x, int y);
pkt_entry *pkt_lookup_or_add_by_id(struct env *e, int id);

pkt_list *pkt_select_at_location(pkt_list *pk, int x,int y);
pkt_list *binpack(pkt_list *pk, int max_capacity, struct env *e);
pkt_list *binpack_add(pkt_list *pk,pkt_list *bag,int max_capacity, struct env *e);
void display_packages_text(FILE *stream, pkt_list *pl);
void remove_dropped_packet(struct env *e);
#endif

