#include "main.h"

player *get_good_player(int soc)
{
  char buf[1024]; /* TODO : greed */
  player *myself = (player*)calloc(1, sizeof(player));
  if( read_line(soc, buf, 1024) < 0)
    return NULL;

  sscanf(buf, "%d %d %d", &myself->id, &myself->capacity, &myself->money);
  myself->x = -1;
  myself->y = -1;
  /* rest is 0/NULL */

  return myself;
}

void display_player(FILE *stream, player *p)
{
#ifdef GUI
  gui_write(&p->id, sizeof(int));
  gui_write(&p->money, sizeof(int));
  gui_write(&p->capacity, sizeof(int));
  gui_write(&p->dead, sizeof(char));
#endif
}

void player_add_adv(env *e, player *p)
{
  if( e->adv.last ) 
    e->adv.last->next = p;
  else
    e->adv.first = p;
  e->adv.last = p;
}

player *player_get_or_create_by_id(int id, env *e)
{
  player *p;

  if(id == e->p->id)
    return e->p;

  for( p = e->adv.first; p; p = p->next)
    if(id == p->id)
      return p;

  p = (player *)calloc(1, sizeof(player));
  p->x = p->y = -1;
  p->capacity = e->initial_capacity;
  p->money    = e->initial_money;
  p->id = id;

  /* rest is already set to zero */
  player_add_adv(e, p);

  return p;
}

void player_update_packages_position(player *p)
{
  pkt_list_entry *ple;
  for(ple = p->packages.first; ple; ple=ple->next)
    {
      ple->entry->x = p->x;
      ple->entry->y = p->y;
    }
}
